<template>
  <div class="block-content">
    <form>
      <div class="form-content">
        <label class="form-label">Zip Code</label>
        <input id="zip" ftype="text" class="form-value" v-model="zipCode.zipCode" />
      </div>
      <div class="err" id="zip-err">
        <p style="color: red;">Zip Code shouldn't be empty,
          or contains less than 5 ciphers!
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">City</label>
        <select  id="city" class="form-value" v-model="zipCode.cityId">
          <option selected> ------- </option>
          <option v-for="city in cities" :key="city.id" :value="city.id"
          v-on:click="this.zipCode.cityId = city.id" >
            {{city.city}}
          </option>
        </select>
      </div>
      <div class="err" id="city-err">
        <p style="color: red;">Please select one value!</p>
      </div>
      <div class="form-content">
        <input type="button" value="Submit and new" class="form-button"
        v-on:click="submit('ZipCode'); this.object = {}" />
        <input type="button" value="Submit" class="form-button"
        id="righter" v-on:click="submit('ZipCodes')" />
      </div>
    </form>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Zip_code',
  data() {
    return {
      cities: [],
      zipCode: {},
    };
  },
  props: {
    object: Number,
  },
  mounted() {
    this.getCity();
    this.get();
  },
  methods: {
    getCity() {
      axios.get('http://localhost:4000/api/cities').then(
        (result) => {
          this.cities = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    get() {
      if (this.object > 0) {
        axios.get(`http://localhost:4000/api/zipCodes/${this.object}`).then(
          (result) => {
            this.zipCode = result.data;
          },
        ).catch((error) => {
          console.log(error);
        });
      }
    },
    validateZip(obj) {
      const reg = /[0-9|A-Z]{2,5}([-| ][0-9|A-Z]{3,4})*/;
      if (obj.zipCode && obj.cityId
        && reg.test(obj.zipCode)) {
        return true;
      }
      if (!obj.zipCode || !reg.test(obj.zipCode)) {
        document.getElementById('zip').style.borderColor = 'red';
        document.getElementById('zip-err').style.display = 'block';
      }
      if (obj.city) {
        document.getElementById('city').style.border = 'red';
        document.getElementById('city-err').style.display = 'block';
      }

      return false;
    },
    submit(component) {
      if (this.object === 0) {
        if (this.validateZip(this.zipCode)) {
          axios.post('http://localhost:4000/api/zipCodes', {
            zipCode: this.zipCode.zipCode,
            cityId: this.zipCode.cityId,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });

          this.nullify();
          this.$emit('change-component', component);
        }
      } else {
        if (this.validateZip(this.zipCode)) {
          axios.patch(`http://localhost:4000/api/zipCodes/${this.object}`, {
            zipCode: this.zipCode.zipCode,
            cityId: this.zipCode.cityId,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
        }
        this.$emit('change-component', component);
        this.$emit('object', 0);
      }
    },
    nullify() {
      document.getElementById('zip').value = '';
    },
  },
};
</script>

<style scoped>
@import "../CSS/actionObject.css";
</style>
